package fr.cnrs.mri.util.database;

import java.io.IOException;
import java.util.Observable;

public class DatabaseLoader extends Observable {
	
	protected static DatabaseLoader dbLoader;
	private DatabaseLoaderView view;
	private String selectedDatabase;
	protected DatabaseUtil databaseLoadertask;
	private Thread task;
	
	public enum Aspect {IS_RUNNING};
	
	public static void main(String [] args) {
		dbLoader = new DatabaseLoader();
		dbLoader.show();
	}

	public void show() {
		this.getView().setVisible(true);
		this.changed("selectedDatabase");
	}

	private void changed(String string) {
		this.setChanged();
		this.notifyObservers(string);
		this.clearChanged();
	}

	private DatabaseLoaderView getView() {
		if (this.view == null) this.view = new DatabaseLoaderView(this);
		return view;
	}

	private void startTask( ) throws IOException {
		this.databaseLoadertask = DatabaseUtil.getInstance();
		databaseLoadertask.setConfig(DatabaseLoaderConfig.getCurrent());
		databaseLoadertask.setDatabase(this.getSelectedDatabase());
		task = new Thread(this.databaseLoadertask);
		task.start();
	}
	
	public void setSelectedDatabase(String string) {
		this.selectedDatabase = string;	
	}
	
	public String getSelectedDatabase() {
		return selectedDatabase;
	}

	public void toggleRunning() {
		if (databaseLoadertask!=null && !databaseLoadertask.isStopped()) this.cancel();
		else
			try {
				this.startTask();
			} catch (IOException e) {
				e.printStackTrace();
				databaseLoadertask.setError(e.getMessage());
			}
		
	}
	
	public void cancel() {
		this.databaseLoadertask.stop();
		while (task.isAlive())
			try {
				Thread.sleep(400);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}	
	}
}
